"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var ConnectCustomKeyStore_1 = require("../model/operations/ConnectCustomKeyStore");
var ConnectCustomKeyStoreCommand = /** @class */ (function () {
    function ConnectCustomKeyStoreCommand(input) {
        this.input = input;
        this.model = ConnectCustomKeyStore_1.ConnectCustomKeyStore;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    ConnectCustomKeyStoreCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return ConnectCustomKeyStoreCommand;
}());
exports.ConnectCustomKeyStoreCommand = ConnectCustomKeyStoreCommand;
//# sourceMappingURL=ConnectCustomKeyStoreCommand.js.map