"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var CreateGrant_1 = require("../model/operations/CreateGrant");
var CreateGrantCommand = /** @class */ (function () {
    function CreateGrantCommand(input) {
        this.input = input;
        this.model = CreateGrant_1.CreateGrant;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    CreateGrantCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return CreateGrantCommand;
}());
exports.CreateGrantCommand = CreateGrantCommand;
//# sourceMappingURL=CreateGrantCommand.js.map