"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var Decrypt_1 = require("../model/operations/Decrypt");
var DecryptCommand = /** @class */ (function () {
    function DecryptCommand(input) {
        this.input = input;
        this.model = Decrypt_1.Decrypt;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DecryptCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DecryptCommand;
}());
exports.DecryptCommand = DecryptCommand;
//# sourceMappingURL=DecryptCommand.js.map