"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DeleteCustomKeyStore_1 = require("../model/operations/DeleteCustomKeyStore");
var DeleteCustomKeyStoreCommand = /** @class */ (function () {
    function DeleteCustomKeyStoreCommand(input) {
        this.input = input;
        this.model = DeleteCustomKeyStore_1.DeleteCustomKeyStore;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DeleteCustomKeyStoreCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DeleteCustomKeyStoreCommand;
}());
exports.DeleteCustomKeyStoreCommand = DeleteCustomKeyStoreCommand;
//# sourceMappingURL=DeleteCustomKeyStoreCommand.js.map