"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DescribeCustomKeyStores_1 = require("../model/operations/DescribeCustomKeyStores");
var DescribeCustomKeyStoresCommand = /** @class */ (function () {
    function DescribeCustomKeyStoresCommand(input) {
        this.input = input;
        this.model = DescribeCustomKeyStores_1.DescribeCustomKeyStores;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DescribeCustomKeyStoresCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DescribeCustomKeyStoresCommand;
}());
exports.DescribeCustomKeyStoresCommand = DescribeCustomKeyStoresCommand;
//# sourceMappingURL=DescribeCustomKeyStoresCommand.js.map