"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DescribeKey_1 = require("../model/operations/DescribeKey");
var DescribeKeyCommand = /** @class */ (function () {
    function DescribeKeyCommand(input) {
        this.input = input;
        this.model = DescribeKey_1.DescribeKey;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DescribeKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DescribeKeyCommand;
}());
exports.DescribeKeyCommand = DescribeKeyCommand;
//# sourceMappingURL=DescribeKeyCommand.js.map