"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DisableKey_1 = require("../model/operations/DisableKey");
var DisableKeyCommand = /** @class */ (function () {
    function DisableKeyCommand(input) {
        this.input = input;
        this.model = DisableKey_1.DisableKey;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DisableKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DisableKeyCommand;
}());
exports.DisableKeyCommand = DisableKeyCommand;
//# sourceMappingURL=DisableKeyCommand.js.map