"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var EnableKey_1 = require("../model/operations/EnableKey");
var EnableKeyCommand = /** @class */ (function () {
    function EnableKeyCommand(input) {
        this.input = input;
        this.model = EnableKey_1.EnableKey;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    EnableKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return EnableKeyCommand;
}());
exports.EnableKeyCommand = EnableKeyCommand;
//# sourceMappingURL=EnableKeyCommand.js.map