"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var Encrypt_1 = require("../model/operations/Encrypt");
var EncryptCommand = /** @class */ (function () {
    function EncryptCommand(input) {
        this.input = input;
        this.model = Encrypt_1.Encrypt;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    EncryptCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return EncryptCommand;
}());
exports.EncryptCommand = EncryptCommand;
//# sourceMappingURL=EncryptCommand.js.map