"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var GenerateDataKey_1 = require("../model/operations/GenerateDataKey");
var GenerateDataKeyCommand = /** @class */ (function () {
    function GenerateDataKeyCommand(input) {
        this.input = input;
        this.model = GenerateDataKey_1.GenerateDataKey;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    GenerateDataKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return GenerateDataKeyCommand;
}());
exports.GenerateDataKeyCommand = GenerateDataKeyCommand;
//# sourceMappingURL=GenerateDataKeyCommand.js.map