"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var GetKeyPolicy_1 = require("../model/operations/GetKeyPolicy");
var GetKeyPolicyCommand = /** @class */ (function () {
    function GetKeyPolicyCommand(input) {
        this.input = input;
        this.model = GetKeyPolicy_1.GetKeyPolicy;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    GetKeyPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return GetKeyPolicyCommand;
}());
exports.GetKeyPolicyCommand = GetKeyPolicyCommand;
//# sourceMappingURL=GetKeyPolicyCommand.js.map