"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var ImportKeyMaterial_1 = require("../model/operations/ImportKeyMaterial");
var ImportKeyMaterialCommand = /** @class */ (function () {
    function ImportKeyMaterialCommand(input) {
        this.input = input;
        this.model = ImportKeyMaterial_1.ImportKeyMaterial;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    ImportKeyMaterialCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return ImportKeyMaterialCommand;
}());
exports.ImportKeyMaterialCommand = ImportKeyMaterialCommand;
//# sourceMappingURL=ImportKeyMaterialCommand.js.map