"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var ListGrants_1 = require("../model/operations/ListGrants");
var ListGrantsCommand = /** @class */ (function () {
    function ListGrantsCommand(input) {
        this.input = input;
        this.model = ListGrants_1.ListGrants;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    ListGrantsCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return ListGrantsCommand;
}());
exports.ListGrantsCommand = ListGrantsCommand;
//# sourceMappingURL=ListGrantsCommand.js.map