"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var ListKeyPolicies_1 = require("../model/operations/ListKeyPolicies");
var ListKeyPoliciesCommand = /** @class */ (function () {
    function ListKeyPoliciesCommand(input) {
        this.input = input;
        this.model = ListKeyPolicies_1.ListKeyPolicies;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    ListKeyPoliciesCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return ListKeyPoliciesCommand;
}());
exports.ListKeyPoliciesCommand = ListKeyPoliciesCommand;
//# sourceMappingURL=ListKeyPoliciesCommand.js.map