"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var PutKeyPolicy_1 = require("../model/operations/PutKeyPolicy");
var PutKeyPolicyCommand = /** @class */ (function () {
    function PutKeyPolicyCommand(input) {
        this.input = input;
        this.model = PutKeyPolicy_1.PutKeyPolicy;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    PutKeyPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return PutKeyPolicyCommand;
}());
exports.PutKeyPolicyCommand = PutKeyPolicyCommand;
//# sourceMappingURL=PutKeyPolicyCommand.js.map