"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var ScheduleKeyDeletion_1 = require("../model/operations/ScheduleKeyDeletion");
var ScheduleKeyDeletionCommand = /** @class */ (function () {
    function ScheduleKeyDeletionCommand(input) {
        this.input = input;
        this.model = ScheduleKeyDeletion_1.ScheduleKeyDeletion;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    ScheduleKeyDeletionCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return ScheduleKeyDeletionCommand;
}());
exports.ScheduleKeyDeletionCommand = ScheduleKeyDeletionCommand;
//# sourceMappingURL=ScheduleKeyDeletionCommand.js.map