"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ConnectCustomKeyStoreInput_1 = require("../shapes/ConnectCustomKeyStoreInput");
var ConnectCustomKeyStoreOutput_1 = require("../shapes/ConnectCustomKeyStoreOutput");
var CloudHsmClusterNotActiveException_1 = require("../shapes/CloudHsmClusterNotActiveException");
var CustomKeyStoreInvalidStateException_1 = require("../shapes/CustomKeyStoreInvalidStateException");
var CustomKeyStoreNotFoundException_1 = require("../shapes/CustomKeyStoreNotFoundException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var CloudHsmClusterInvalidConfigurationException_1 = require("../shapes/CloudHsmClusterInvalidConfigurationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.ConnectCustomKeyStore = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "ConnectCustomKeyStore",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: ConnectCustomKeyStoreInput_1.ConnectCustomKeyStoreInput
    },
    output: {
        shape: ConnectCustomKeyStoreOutput_1.ConnectCustomKeyStoreOutput
    },
    errors: [
        {
            shape: CloudHsmClusterNotActiveException_1.CloudHsmClusterNotActiveException
        },
        {
            shape: CustomKeyStoreInvalidStateException_1.CustomKeyStoreInvalidStateException
        },
        {
            shape: CustomKeyStoreNotFoundException_1.CustomKeyStoreNotFoundException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: CloudHsmClusterInvalidConfigurationException_1.CloudHsmClusterInvalidConfigurationException
        }
    ]
};
//# sourceMappingURL=ConnectCustomKeyStore.js.map