"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CreateAliasInput_1 = require("../shapes/CreateAliasInput");
var CreateAliasOutput_1 = require("../shapes/CreateAliasOutput");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var AlreadyExistsException_1 = require("../shapes/AlreadyExistsException");
var NotFoundException_1 = require("../shapes/NotFoundException");
var InvalidAliasNameException_1 = require("../shapes/InvalidAliasNameException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var LimitExceededException_1 = require("../shapes/LimitExceededException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateAlias = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateAlias",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateAliasInput_1.CreateAliasInput
    },
    output: {
        shape: CreateAliasOutput_1.CreateAliasOutput
    },
    errors: [
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: AlreadyExistsException_1.AlreadyExistsException
        },
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: InvalidAliasNameException_1.InvalidAliasNameException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: LimitExceededException_1.LimitExceededException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        }
    ]
};
//# sourceMappingURL=CreateAlias.js.map