"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CreateCustomKeyStoreInput_1 = require("../shapes/CreateCustomKeyStoreInput");
var CreateCustomKeyStoreOutput_1 = require("../shapes/CreateCustomKeyStoreOutput");
var CloudHsmClusterInUseException_1 = require("../shapes/CloudHsmClusterInUseException");
var CustomKeyStoreNameInUseException_1 = require("../shapes/CustomKeyStoreNameInUseException");
var CloudHsmClusterNotFoundException_1 = require("../shapes/CloudHsmClusterNotFoundException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var CloudHsmClusterNotActiveException_1 = require("../shapes/CloudHsmClusterNotActiveException");
var IncorrectTrustAnchorException_1 = require("../shapes/IncorrectTrustAnchorException");
var CloudHsmClusterInvalidConfigurationException_1 = require("../shapes/CloudHsmClusterInvalidConfigurationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateCustomKeyStore = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateCustomKeyStore",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateCustomKeyStoreInput_1.CreateCustomKeyStoreInput
    },
    output: {
        shape: CreateCustomKeyStoreOutput_1.CreateCustomKeyStoreOutput
    },
    errors: [
        {
            shape: CloudHsmClusterInUseException_1.CloudHsmClusterInUseException
        },
        {
            shape: CustomKeyStoreNameInUseException_1.CustomKeyStoreNameInUseException
        },
        {
            shape: CloudHsmClusterNotFoundException_1.CloudHsmClusterNotFoundException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: CloudHsmClusterNotActiveException_1.CloudHsmClusterNotActiveException
        },
        {
            shape: IncorrectTrustAnchorException_1.IncorrectTrustAnchorException
        },
        {
            shape: CloudHsmClusterInvalidConfigurationException_1.CloudHsmClusterInvalidConfigurationException
        }
    ]
};
//# sourceMappingURL=CreateCustomKeyStore.js.map