"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CreateGrantInput_1 = require("../shapes/CreateGrantInput");
var CreateGrantOutput_1 = require("../shapes/CreateGrantOutput");
var NotFoundException_1 = require("../shapes/NotFoundException");
var DisabledException_1 = require("../shapes/DisabledException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var InvalidGrantTokenException_1 = require("../shapes/InvalidGrantTokenException");
var LimitExceededException_1 = require("../shapes/LimitExceededException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateGrant = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateGrant",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateGrantInput_1.CreateGrantInput
    },
    output: {
        shape: CreateGrantOutput_1.CreateGrantOutput
    },
    errors: [
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: DisabledException_1.DisabledException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: InvalidGrantTokenException_1.InvalidGrantTokenException
        },
        {
            shape: LimitExceededException_1.LimitExceededException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        }
    ]
};
//# sourceMappingURL=CreateGrant.js.map