"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CreateKeyInput_1 = require("../shapes/CreateKeyInput");
var CreateKeyOutput_1 = require("../shapes/CreateKeyOutput");
var MalformedPolicyDocumentException_1 = require("../shapes/MalformedPolicyDocumentException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var UnsupportedOperationException_1 = require("../shapes/UnsupportedOperationException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var LimitExceededException_1 = require("../shapes/LimitExceededException");
var TagException_1 = require("../shapes/TagException");
var CustomKeyStoreNotFoundException_1 = require("../shapes/CustomKeyStoreNotFoundException");
var CustomKeyStoreInvalidStateException_1 = require("../shapes/CustomKeyStoreInvalidStateException");
var CloudHsmClusterInvalidConfigurationException_1 = require("../shapes/CloudHsmClusterInvalidConfigurationException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateKey = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateKey",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateKeyInput_1.CreateKeyInput
    },
    output: {
        shape: CreateKeyOutput_1.CreateKeyOutput
    },
    errors: [
        {
            shape: MalformedPolicyDocumentException_1.MalformedPolicyDocumentException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: UnsupportedOperationException_1.UnsupportedOperationException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: LimitExceededException_1.LimitExceededException
        },
        {
            shape: TagException_1.TagException
        },
        {
            shape: CustomKeyStoreNotFoundException_1.CustomKeyStoreNotFoundException
        },
        {
            shape: CustomKeyStoreInvalidStateException_1.CustomKeyStoreInvalidStateException
        },
        {
            shape: CloudHsmClusterInvalidConfigurationException_1.CloudHsmClusterInvalidConfigurationException
        }
    ]
};
//# sourceMappingURL=CreateKey.js.map