"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DescribeKeyInput_1 = require("../shapes/DescribeKeyInput");
var DescribeKeyOutput_1 = require("../shapes/DescribeKeyOutput");
var NotFoundException_1 = require("../shapes/NotFoundException");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.DescribeKey = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "DescribeKey",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: DescribeKeyInput_1.DescribeKeyInput
    },
    output: {
        shape: DescribeKeyOutput_1.DescribeKeyOutput
    },
    errors: [
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        }
    ]
};
//# sourceMappingURL=DescribeKey.js.map