"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GetParametersForImportInput_1 = require("../shapes/GetParametersForImportInput");
var GetParametersForImportOutput_1 = require("../shapes/GetParametersForImportOutput");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var UnsupportedOperationException_1 = require("../shapes/UnsupportedOperationException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var NotFoundException_1 = require("../shapes/NotFoundException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.GetParametersForImport = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "GetParametersForImport",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: GetParametersForImportInput_1.GetParametersForImportInput
    },
    output: {
        shape: GetParametersForImportOutput_1.GetParametersForImportOutput
    },
    errors: [
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: UnsupportedOperationException_1.UnsupportedOperationException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        }
    ]
};
//# sourceMappingURL=GetParametersForImport.js.map