"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ImportKeyMaterialInput_1 = require("../shapes/ImportKeyMaterialInput");
var ImportKeyMaterialOutput_1 = require("../shapes/ImportKeyMaterialOutput");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var UnsupportedOperationException_1 = require("../shapes/UnsupportedOperationException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var NotFoundException_1 = require("../shapes/NotFoundException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var InvalidCiphertextException_1 = require("../shapes/InvalidCiphertextException");
var IncorrectKeyMaterialException_1 = require("../shapes/IncorrectKeyMaterialException");
var ExpiredImportTokenException_1 = require("../shapes/ExpiredImportTokenException");
var InvalidImportTokenException_1 = require("../shapes/InvalidImportTokenException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.ImportKeyMaterial = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "ImportKeyMaterial",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: ImportKeyMaterialInput_1.ImportKeyMaterialInput
    },
    output: {
        shape: ImportKeyMaterialOutput_1.ImportKeyMaterialOutput
    },
    errors: [
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: UnsupportedOperationException_1.UnsupportedOperationException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        },
        {
            shape: InvalidCiphertextException_1.InvalidCiphertextException
        },
        {
            shape: IncorrectKeyMaterialException_1.IncorrectKeyMaterialException
        },
        {
            shape: ExpiredImportTokenException_1.ExpiredImportTokenException
        },
        {
            shape: InvalidImportTokenException_1.InvalidImportTokenException
        }
    ]
};
//# sourceMappingURL=ImportKeyMaterial.js.map