"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ListGrantsInput_1 = require("../shapes/ListGrantsInput");
var ListGrantsOutput_1 = require("../shapes/ListGrantsOutput");
var NotFoundException_1 = require("../shapes/NotFoundException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var InvalidMarkerException_1 = require("../shapes/InvalidMarkerException");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.ListGrants = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "ListGrants",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: ListGrantsInput_1.ListGrantsInput
    },
    output: {
        shape: ListGrantsOutput_1.ListGrantsOutput
    },
    errors: [
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: InvalidMarkerException_1.InvalidMarkerException
        },
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        }
    ]
};
//# sourceMappingURL=ListGrants.js.map