"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PutKeyPolicyInput_1 = require("../shapes/PutKeyPolicyInput");
var PutKeyPolicyOutput_1 = require("../shapes/PutKeyPolicyOutput");
var NotFoundException_1 = require("../shapes/NotFoundException");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var MalformedPolicyDocumentException_1 = require("../shapes/MalformedPolicyDocumentException");
var DependencyTimeoutException_1 = require("../shapes/DependencyTimeoutException");
var UnsupportedOperationException_1 = require("../shapes/UnsupportedOperationException");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var LimitExceededException_1 = require("../shapes/LimitExceededException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.PutKeyPolicy = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "PutKeyPolicy",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: PutKeyPolicyInput_1.PutKeyPolicyInput
    },
    output: {
        shape: PutKeyPolicyOutput_1.PutKeyPolicyOutput
    },
    errors: [
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: MalformedPolicyDocumentException_1.MalformedPolicyDocumentException
        },
        {
            shape: DependencyTimeoutException_1.DependencyTimeoutException
        },
        {
            shape: UnsupportedOperationException_1.UnsupportedOperationException
        },
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: LimitExceededException_1.LimitExceededException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        }
    ]
};
//# sourceMappingURL=PutKeyPolicy.js.map