"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TagResourceInput_1 = require("../shapes/TagResourceInput");
var TagResourceOutput_1 = require("../shapes/TagResourceOutput");
var KMSInternalException_1 = require("../shapes/KMSInternalException");
var NotFoundException_1 = require("../shapes/NotFoundException");
var InvalidArnException_1 = require("../shapes/InvalidArnException");
var KMSInvalidStateException_1 = require("../shapes/KMSInvalidStateException");
var LimitExceededException_1 = require("../shapes/LimitExceededException");
var TagException_1 = require("../shapes/TagException");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.TagResource = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "TagResource",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: TagResourceInput_1.TagResourceInput
    },
    output: {
        shape: TagResourceOutput_1.TagResourceOutput
    },
    errors: [
        {
            shape: KMSInternalException_1.KMSInternalException
        },
        {
            shape: NotFoundException_1.NotFoundException
        },
        {
            shape: InvalidArnException_1.InvalidArnException
        },
        {
            shape: KMSInvalidStateException_1.KMSInvalidStateException
        },
        {
            shape: LimitExceededException_1.LimitExceededException
        },
        {
            shape: TagException_1.TagException
        }
    ]
};
//# sourceMappingURL=TagResource.js.map